Index: lemon/adaptors.h
===================================================================
--- lemon/adaptors.h	(revision 464)
+++ lemon/adaptors.h	(revision 512)
@@ -1030,21 +1033,22 @@
       template <typename CMap>
       NodeMap& operator=(const CMap& cmap) {
-        MapParent::operator=(cmap);
+        Parent::operator=(cmap);
         return *this;
       }
     };
 
-    template <typename _Value>
-    class ArcMap : public SubMapExtender<Adaptor,
-      typename Parent::template ArcMap<_Value> > {
+    template <typename V>
+    class ArcMap 
+      : public SubMapExtender<SubGraphBase<GR, NF, EF, ch>,
+          LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, ArcMap<V>)> {
     public:
-      typedef _Value Value;
-      typedef SubMapExtender<Adaptor, typename Parent::
-                             template ArcMap<Value> > MapParent;
-
-      ArcMap(const Adaptor& adaptor)
-        : MapParent(adaptor) {}
-      ArcMap(const Adaptor& adaptor, const Value& value)
-        : MapParent(adaptor, value) {}
+      typedef V Value;
+      typedef SubMapExtender<SubGraphBase<GR, NF, EF, ch>, 
+        LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, ArcMap<V>)> Parent;
+
+      ArcMap(const SubGraphBase<GR, NF, EF, ch>& adaptor)
+        : Parent(adaptor) {}
+      ArcMap(const SubGraphBase<GR, NF, EF, ch>& adaptor, const V& value)
+        : Parent(adaptor, value) {}
 
     private:
@@ -1055,22 +1059,23 @@
       template <typename CMap>
       ArcMap& operator=(const CMap& cmap) {
-        MapParent::operator=(cmap);
+        Parent::operator=(cmap);
         return *this;
       }
     };
 
-    template <typename _Value>
-    class EdgeMap : public SubMapExtender<Adaptor,
-      typename Parent::template EdgeMap<_Value> > {
+    template <typename V>
+    class EdgeMap 
+      : public SubMapExtender<SubGraphBase<GR, NF, EF, ch>,
+        LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, EdgeMap<V>)> {
     public:
-      typedef _Value Value;
-      typedef SubMapExtender<Adaptor, typename Parent::
-                             template EdgeMap<Value> > MapParent;
-
-      EdgeMap(const Adaptor& adaptor)
-        : MapParent(adaptor) {}
-
-      EdgeMap(const Adaptor& adaptor, const Value& value)
-        : MapParent(adaptor, value) {}
+      typedef V Value;
+      typedef SubMapExtender<SubGraphBase<GR, NF, EF, ch>, 
+        LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, EdgeMap<V>)> Parent;
+
+      EdgeMap(const SubGraphBase<GR, NF, EF, ch>& adaptor)
+        : Parent(adaptor) {}
+
+      EdgeMap(const SubGraphBase<GR, NF, EF, ch>& adaptor, const V& value)
+        : Parent(adaptor, value) {}
 
     private:
@@ -1081,5 +1086,5 @@
       template <typename CMap>
       EdgeMap& operator=(const CMap& cmap) {
-        MapParent::operator=(cmap);
+        Parent::operator=(cmap);
         return *this;
       }
@@ -1088,25 +1093,24 @@
   };
 
-  template <typename _Graph, typename _NodeFilterMap, typename _EdgeFilterMap>
-  class SubGraphBase<_Graph, _NodeFilterMap, _EdgeFilterMap, false>
-    : public GraphAdaptorBase<_Graph> {
-  public:
-    typedef _Graph Graph;
-    typedef _NodeFilterMap NodeFilterMap;
-    typedef _EdgeFilterMap EdgeFilterMap;
+  template <typename GR, typename NF, typename EF>
+  class SubGraphBase<GR, NF, EF, false>
+    : public GraphAdaptorBase<GR> {
+  public:
+    typedef GR Graph;
+    typedef NF NodeFilterMap;
+    typedef EF EdgeFilterMap;
 
     typedef SubGraphBase Adaptor;
-    typedef GraphAdaptorBase<_Graph> Parent;
+    typedef GraphAdaptorBase<GR> Parent;
   protected:
-    NodeFilterMap* _node_filter_map;
-    EdgeFilterMap* _edge_filter_map;
-    SubGraphBase() : Parent(),
-                     _node_filter_map(0), _edge_filter_map(0) { }
-
-    void setNodeFilterMap(NodeFilterMap& node_filter_map) {
-      _node_filter_map=&node_filter_map;
-    }
-    void setEdgeFilterMap(EdgeFilterMap& edge_filter_map) {
-      _edge_filter_map=&edge_filter_map;
+    NF* _node_filter;
+    EF* _edge_filter;
+    SubGraphBase() 
+	  : Parent(), _node_filter(0), _edge_filter(0) { }
+
+    void initialize(GR& graph, NF& node_filter, EF& edge_filter) {
+      Parent::initialize(graph);
+      _node_filter = &node_filter;
+      _edge_filter = &edge_filter;
     }
 
@@ -1119,63 +1123,63 @@
     void first(Node& i) const {
       Parent::first(i);
-      while (i!=INVALID && !(*_node_filter_map)[i]) Parent::next(i);
+      while (i!=INVALID && !(*_node_filter)[i]) Parent::next(i);
     }
 
     void first(Arc& i) const {
       Parent::first(i);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::next(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::next(i);
     }
 
     void first(Edge& i) const {
       Parent::first(i);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::next(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::next(i);
     }
 
     void firstIn(Arc& i, const Node& n) const {
       Parent::firstIn(i, n);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::nextIn(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::nextIn(i);
     }
 
     void firstOut(Arc& i, const Node& n) const {
       Parent::firstOut(i, n);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::nextOut(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::nextOut(i);
     }
 
     void firstInc(Edge& i, bool& d, const Node& n) const {
       Parent::firstInc(i, d, n);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::nextInc(i, d);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::nextInc(i, d);
     }
 
     void next(Node& i) const {
       Parent::next(i);
-      while (i!=INVALID && !(*_node_filter_map)[i]) Parent::next(i);
+      while (i!=INVALID && !(*_node_filter)[i]) Parent::next(i);
     }
     void next(Arc& i) const {
       Parent::next(i);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::next(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::next(i);
     }
     void next(Edge& i) const {
       Parent::next(i);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::next(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::next(i);
     }
     void nextIn(Arc& i) const {
       Parent::nextIn(i);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::nextIn(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::nextIn(i);
     }
 
     void nextOut(Arc& i) const {
       Parent::nextOut(i);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::nextOut(i);
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::nextOut(i);
     }
     void nextInc(Edge& i, bool& d) const {
       Parent::nextInc(i, d);
-      while (i!=INVALID && !(*_edge_filter_map)[i]) Parent::nextInc(i, d);
-    }
-
-    void status(const Node& n, bool v) const { _node_filter_map->set(n, v); }
-    void status(const Edge& e, bool v) const { _edge_filter_map->set(e, v); }
-
-    bool status(const Node& n) const { return (*_node_filter_map)[n]; }
-    bool status(const Edge& e) const { return (*_edge_filter_map)[e]; }
+      while (i!=INVALID && !(*_edge_filter)[i]) Parent::nextInc(i, d);
+    }
+
+    void status(const Node& n, bool v) const { _node_filter->set(n, v); }
+    void status(const Edge& e, bool v) const { _edge_filter->set(e, v); }
+
+    bool status(const Node& n) const { return (*_node_filter)[n]; }
+    bool status(const Edge& e) const { return (*_edge_filter)[e]; }
 
     typedef False NodeNumTag;
@@ -1187,5 +1191,5 @@
                 const Arc& prev = INVALID) const {
       Arc arc = Parent::findArc(u, v, prev);
-      while (arc != INVALID && !(*_edge_filter_map)[arc]) {
+      while (arc != INVALID && !(*_edge_filter)[arc]) {
         arc = Parent::findArc(u, v, arc);
       }
@@ -1197,5 +1201,5 @@
                   const Edge& prev = INVALID) const {
       Edge edge = Parent::findEdge(u, v, prev);
-      while (edge != INVALID && !(*_edge_filter_map)[edge]) {
+      while (edge != INVALID && !(*_edge_filter)[edge]) {
         edge = Parent::findEdge(u, v, edge);
       }
@@ -1203,16 +1207,17 @@
     }
 
-    template <typename _Value>
-    class NodeMap : public SubMapExtender<Adaptor,
-      typename Parent::template NodeMap<_Value> > {
+    template <typename V>
+    class NodeMap 
+      : public SubMapExtender<SubGraphBase<GR, NF, EF, false>,
+          LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, NodeMap<V>)> {
     public:
-      typedef _Value Value;
-      typedef SubMapExtender<Adaptor, typename Parent::
-                             template NodeMap<Value> > MapParent;
-
-      NodeMap(const Adaptor& adaptor)
-        : MapParent(adaptor) {}
-      NodeMap(const Adaptor& adaptor, const Value& value)
-        : MapParent(adaptor, value) {}
+      typedef V Value;
+      typedef SubMapExtender<SubGraphBase<GR, NF, EF, false>, 
+        LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, NodeMap<V>)> Parent;
+
+      NodeMap(const SubGraphBase<GR, NF, EF, false>& adaptor)
+        : Parent(adaptor) {}
+      NodeMap(const SubGraphBase<GR, NF, EF, false>& adaptor, const V& value)
+        : Parent(adaptor, value) {}
 
     private:
@@ -1223,21 +1228,22 @@
       template <typename CMap>
       NodeMap& operator=(const CMap& cmap) {
-        MapParent::operator=(cmap);
+        Parent::operator=(cmap);
         return *this;
       }
     };
 
-    template <typename _Value>
-    class ArcMap : public SubMapExtender<Adaptor,
-      typename Parent::template ArcMap<_Value> > {
+    template <typename V>
+    class ArcMap 
+      : public SubMapExtender<SubGraphBase<GR, NF, EF, false>,
+          LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, ArcMap<V>)> {
     public:
-      typedef _Value Value;
-      typedef SubMapExtender<Adaptor, typename Parent::
-                             template ArcMap<Value> > MapParent;
-
-      ArcMap(const Adaptor& adaptor)
-        : MapParent(adaptor) {}
-      ArcMap(const Adaptor& adaptor, const Value& value)
-        : MapParent(adaptor, value) {}
+      typedef V Value;
+      typedef SubMapExtender<SubGraphBase<GR, NF, EF, false>, 
+        LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, ArcMap<V>)> Parent;
+
+      ArcMap(const SubGraphBase<GR, NF, EF, false>& adaptor)
+        : Parent(adaptor) {}
+      ArcMap(const SubGraphBase<GR, NF, EF, false>& adaptor, const V& value)
+        : Parent(adaptor, value) {}
 
     private:
@@ -1248,22 +1254,23 @@
       template <typename CMap>
       ArcMap& operator=(const CMap& cmap) {
-        MapParent::operator=(cmap);
+        Parent::operator=(cmap);
         return *this;
       }
     };
 
-    template <typename _Value>
-    class EdgeMap : public SubMapExtender<Adaptor,
-      typename Parent::template EdgeMap<_Value> > {
+    template <typename V>
+    class EdgeMap 
+      : public SubMapExtender<SubGraphBase<GR, NF, EF, false>,
+        LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, EdgeMap<V>)> {
     public:
-      typedef _Value Value;
-      typedef SubMapExtender<Adaptor, typename Parent::
-                             template EdgeMap<Value> > MapParent;
-
-      EdgeMap(const Adaptor& adaptor)
-        : MapParent(adaptor) {}
-
-      EdgeMap(const Adaptor& adaptor, const _Value& value)
-        : MapParent(adaptor, value) {}
+      typedef V Value;
+      typedef SubMapExtender<SubGraphBase<GR, NF, EF, false>, 
+		  LEMON_SCOPE_FIX(GraphAdaptorBase<GR>, EdgeMap<V>)> Parent;
+
+      EdgeMap(const SubGraphBase<GR, NF, EF, false>& adaptor)
+        : Parent(adaptor) {}
+
+      EdgeMap(const SubGraphBase<GR, NF, EF, false>& adaptor, const V& value)
+        : Parent(adaptor, value) {}
 
     private:
@@ -1274,5 +1281,5 @@
       template <typename CMap>
       EdgeMap& operator=(const CMap& cmap) {
-        MapParent::operator=(cmap);
+        Parent::operator=(cmap);
         return *this;
       }
@@ -1333,5 +1340,5 @@
     typedef EF EdgeFilterMap;
 
-    typedef GraphAdaptorExtender< SubGraphBase<GR, NF, EF, true> >
+    typedef GraphAdaptorExtender<SubGraphBase<GR, NF, EF, true> >
       Parent;
 
@@ -1347,9 +1354,6 @@
     /// Creates a subgraph for the given graph with the given node
     /// and edge filter maps.
-    SubGraph(Graph& graph, NodeFilterMap& node_filter_map,
-             EdgeFilterMap& edge_filter_map) {
-      setGraph(graph);
-      setNodeFilterMap(node_filter_map);
-      setEdgeFilterMap(edge_filter_map);
+    SubGraph(GR& graph, NF& node_filter, EF& edge_filter) {
+      initialize(graph, node_filter, edge_filter);
     }
 
@@ -1415,32 +1419,28 @@
   template<typename GR, typename NF, typename EF>
   SubGraph<const GR, NF, EF>
-  subGraph(const GR& graph,
-           NF& node_filter_map, EF& edge_filter_map) {
+  subGraph(const GR& graph, NF& node_filter, EF& edge_filter) {
     return SubGraph<const GR, NF, EF>
-      (graph, node_filter_map, edge_filter_map);
+      (graph, node_filter, edge_filter);
   }
 
   template<typename GR, typename NF, typename EF>
   SubGraph<const GR, const NF, EF>
-  subGraph(const GR& graph,
-           const NF& node_filter_map, EF& edge_filter_map) {
+  subGraph(const GR& graph, const NF& node_filter, EF& edge_filter) {
     return SubGraph<const GR, const NF, EF>
-      (graph, node_filter_map, edge_filter_map);
+      (graph, node_filter, edge_filter);
   }
 
   template<typename GR, typename NF, typename EF>
   SubGraph<const GR, NF, const EF>
-  subGraph(const GR& graph,
-           NF& node_filter_map, const EF& edge_filter_map) {
+  subGraph(const GR& graph, NF& node_filter, const EF& edge_filter) {
     return SubGraph<const GR, NF, const EF>
-      (graph, node_filter_map, edge_filter_map);
+      (graph, node_filter, edge_filter);
   }
 
   template<typename GR, typename NF, typename EF>
   SubGraph<const GR, const NF, const EF>
-  subGraph(const GR& graph,
-           const NF& node_filter_map, const EF& edge_filter_map) {
+  subGraph(const GR& graph, const NF& node_filter, const EF& edge_filter) {
     return SubGraph<const GR, const NF, const EF>
-      (graph, node_filter_map, edge_filter_map);
+      (graph, node_filter, edge_filter);
   }
 
@@ -1482,5 +1482,6 @@
   class FilterNodes :
     public DigraphAdaptorExtender<
-      SubDigraphBase<GR, NF, ConstMap<typename GR::Arc, bool>, true> > {
+      SubDigraphBase<GR, NF, ConstMap<typename GR::Arc, Const<bool, true> >,
+                     true> > {
 #endif
   public:
@@ -1490,15 +1491,13 @@
 
     typedef DigraphAdaptorExtender<
-      SubDigraphBase<GR, NF, ConstMap<typename GR::Arc, bool>, true> >
-      Parent;
+      SubDigraphBase<GR, NF, ConstMap<typename GR::Arc, Const<bool, true> >, 
+                     true> > Parent;
 
     typedef typename Parent::Node Node;
 
   protected:
-    ConstMap<typename Digraph::Arc, bool> const_true_map;
-
-    FilterNodes() : const_true_map(true) {
-      Parent::setArcFilterMap(const_true_map);
-    }
+    ConstMap<typename Digraph::Arc, Const<bool, true> > const_true_map;
+
+    FilterNodes() : const_true_map() {}
 
   public:
@@ -1508,10 +1507,8 @@
     /// Creates a subgraph for the given digraph or graph with the
     /// given node filter map.
-    FilterNodes(GR& graph, NodeFilterMap& node_filter) :
-      Parent(), const_true_map(true)
+    FilterNodes(GR& graph, NF& node_filter) 
+      : Parent(), const_true_map()
     {
-      Parent::setDigraph(graph);
-      Parent::setNodeFilterMap(node_filter);
-      Parent::setArcFilterMap(const_true_map);
+      Parent::initialize(graph, node_filter, const_true_map);
     }
 
@@ -1548,5 +1545,6 @@
                     typename enable_if<UndirectedTagIndicator<GR> >::type> :
     public GraphAdaptorExtender<
-      SubGraphBase<GR, NF, ConstMap<typename GR::Edge, bool>, true> > {
+      SubGraphBase<GR, NF, ConstMap<typename GR::Edge, Const<bool, true> >, 
+                   true> > {
 
   public:
@@ -1554,22 +1552,18 @@
     typedef NF NodeFilterMap;
     typedef GraphAdaptorExtender<
-      SubGraphBase<GR, NF, ConstMap<typename GR::Edge, bool>, true> >
-      Parent;
+      SubGraphBase<GR, NF, ConstMap<typename GR::Edge, Const<bool, true> >, 
+                   true> > Parent;
 
     typedef typename Parent::Node Node;
   protected:
-    ConstMap<typename Graph::Edge, bool> const_true_map;
-
-    FilterNodes() : const_true_map(true) {
-      Parent::setEdgeFilterMap(const_true_map);
-    }
-
-  public:
-
-    FilterNodes(Graph& _graph, NodeFilterMap& node_filter_map) :
-      Parent(), const_true_map(true) {
-      Parent::setGraph(_graph);
-      Parent::setNodeFilterMap(node_filter_map);
-      Parent::setEdgeFilterMap(const_true_map);
+    ConstMap<typename GR::Edge, Const<bool, true> > const_true_map;
+
+    FilterNodes() : const_true_map() {}
+
+  public:
+
+    FilterNodes(GR& graph, NodeFilterMap& node_filter) :
+      Parent(), const_true_map() {
+      Parent::initialize(graph, node_filter, const_true_map);
     }
 
@@ -1589,12 +1583,12 @@
   template<typename GR, typename NF>
   FilterNodes<const GR, NF>
-  filterNodes(const GR& graph, NF& node_filter_map) {
-    return FilterNodes<const GR, NF>(graph, node_filter_map);
+  filterNodes(const GR& graph, NF& node_filter) {
+    return FilterNodes<const GR, NF>(graph, node_filter);
   }
 
   template<typename GR, typename NF>
   FilterNodes<const GR, const NF>
-  filterNodes(const GR& graph, const NF& node_filter_map) {
-    return FilterNodes<const GR, const NF>(graph, node_filter_map);
+  filterNodes(const GR& graph, const NF& node_filter) {
+    return FilterNodes<const GR, const NF>(graph, node_filter);
   }
 
@@ -1613,5 +1607,5 @@
   /// parameter is set to be \c const.
   ///
-  /// \tparam GR The type of the adapted digraph.
+  /// \tparam DGR The type of the adapted digraph.
   /// It must conform to the \ref concepts::Digraph "Digraph" concept.
   /// It can also be specified to be \c const.
@@ -1619,37 +1613,36 @@
   /// It must be a \c bool (or convertible) arc map of the
   /// adapted digraph. The default type is
-  /// \ref concepts::Digraph::ArcMap "GR::ArcMap<bool>".
+  /// \ref concepts::Digraph::ArcMap "DGR::ArcMap<bool>".
   ///
   /// \note The \c Node and \c Arc types of this adaptor and the adapted
   /// digraph are convertible to each other.
 #ifdef DOXYGEN
-  template<typename GR,
+  template<typename DGR,
            typename AF>
   class FilterArcs {
 #else
-  template<typename GR,
-           typename AF = typename GR::template ArcMap<bool> >
+  template<typename DGR,
+           typename AF = typename DGR::template ArcMap<bool> >
   class FilterArcs :
     public DigraphAdaptorExtender<
-      SubDigraphBase<GR, ConstMap<typename GR::Node, bool>, AF, false> > {
+      SubDigraphBase<DGR, ConstMap<typename DGR::Node, Const<bool, true> >,
+                     AF, false> > {
 #endif
   public:
     /// The type of the adapted digraph.
-    typedef GR Digraph;
+    typedef DGR Digraph;
     /// The type of the arc filter map.
     typedef AF ArcFilterMap;
 
     typedef DigraphAdaptorExtender<
-      SubDigraphBase<GR, ConstMap<typename GR::Node, bool>, AF, false> >
-      Parent;
+      SubDigraphBase<DGR, ConstMap<typename DGR::Node, Const<bool, true> >, 
+                     AF, false> > Parent;
 
     typedef typename Parent::Arc Arc;
 
   protected:
-    ConstMap<typename Digraph::Node, bool> const_true_map;
-
-    FilterArcs() : const_true_map(true) {
-      Parent::setNodeFilterMap(const_true_map);
-    }
+    ConstMap<typename DGR::Node, Const<bool, true> > const_true_map;
+
+    FilterArcs() : const_true_map() {}
 
   public:
@@ -1659,9 +1652,7 @@
     /// Creates a subdigraph for the given digraph with the given arc
     /// filter map.
-    FilterArcs(Digraph& digraph, ArcFilterMap& arc_filter)
-      : Parent(), const_true_map(true) {
-      Parent::setDigraph(digraph);
-      Parent::setNodeFilterMap(const_true_map);
-      Parent::setArcFilterMap(arc_filter);
+    FilterArcs(DGR& digraph, ArcFilterMap& arc_filter)
+      : Parent(), const_true_map() {
+      Parent::initialize(digraph, const_true_map, arc_filter);
     }
 
@@ -1699,14 +1690,14 @@
   /// \ingroup graph_adaptors
   /// \relates FilterArcs
-  template<typename GR, typename AF>
-  FilterArcs<const GR, AF>
-  filterArcs(const GR& digraph, AF& arc_filter_map) {
-    return FilterArcs<const GR, AF>(digraph, arc_filter_map);
+  template<typename DGR, typename AF>
+  FilterArcs<const DGR, AF>
+  filterArcs(const DGR& digraph, AF& arc_filter) {
+    return FilterArcs<const DGR, AF>(digraph, arc_filter);
   }
 
-  template<typename GR, typename AF>
-  FilterArcs<const GR, const AF>
-  filterArcs(const GR& digraph, const AF& arc_filter_map) {
-    return FilterArcs<const GR, const AF>(digraph, arc_filter_map);
+  template<typename DGR, typename AF>
+  FilterArcs<const DGR, const AF>
+  filterArcs(const DGR& digraph, const AF& arc_filter) {
+    return FilterArcs<const DGR, const AF>(digraph, arc_filter);
   }
 
@@ -1744,5 +1735,6 @@
   class FilterEdges :
     public GraphAdaptorExtender<
-      SubGraphBase<GR, ConstMap<typename GR::Node,bool>, EF, false> > {
+      SubGraphBase<GR, ConstMap<typename GR::Node, Const<bool, true> >, 
+                   EF, false> > {
 #endif
   public:
@@ -1753,11 +1745,11 @@
 
     typedef GraphAdaptorExtender<
-      SubGraphBase<GR, ConstMap<typename GR::Node,bool>, EF, false> >
-      Parent;
+      SubGraphBase<GR, ConstMap<typename GR::Node, Const<bool, true > >, 
+                   EF, false> > Parent;
 
     typedef typename Parent::Edge Edge;
 
   protected:
-    ConstMap<typename Graph::Node, bool> const_true_map;
+    ConstMap<typename GR::Node, Const<bool, true> > const_true_map;
 
     FilterEdges() : const_true_map(true) {
@@ -1771,9 +1763,7 @@
     /// Creates a subgraph for the given graph with the given edge
     /// filter map.
-    FilterEdges(Graph& graph, EdgeFilterMap& edge_filter_map) :
-      Parent(), const_true_map(true) {
-      Parent::setGraph(graph);
-      Parent::setNodeFilterMap(const_true_map);
-      Parent::setEdgeFilterMap(edge_filter_map);
+    FilterEdges(GR& graph, EF& edge_filter) 
+      : Parent(), const_true_map() {
+      Parent::initialize(graph, const_true_map, edge_filter);
     }
 
@@ -1813,19 +1803,19 @@
   template<typename GR, typename EF>
   FilterEdges<const GR, EF>
-  filterEdges(const GR& graph, EF& edge_filter_map) {
-    return FilterEdges<const GR, EF>(graph, edge_filter_map);
+  filterEdges(const GR& graph, EF& edge_filter) {
+    return FilterEdges<const GR, EF>(graph, edge_filter);
   }
 
   template<typename GR, typename EF>
   FilterEdges<const GR, const EF>
-  filterEdges(const GR& graph, const EF& edge_filter_map) {
-    return FilterEdges<const GR, const EF>(graph, edge_filter_map);
+  filterEdges(const GR& graph, const EF& edge_filter) {
+    return FilterEdges<const GR, const EF>(graph, edge_filter);
   }
 
 
-  template <typename _Digraph>
+  template <typename DGR>
   class UndirectorBase {
   public:
-    typedef _Digraph Digraph;
+    typedef DGR Digraph;
     typedef UndirectorBase Adaptor;
 
@@ -2063,9 +2053,9 @@
   private:
 
-    template <typename _Value>
+    template <typename V>
     class ArcMapBase {
     private:
 
-      typedef typename Digraph::template ArcMap<_Value> MapImpl;
+      typedef typename DGR::template ArcMap<V> MapImpl;
 
     public:
@@ -2073,5 +2063,5 @@
       typedef typename MapTraits<MapImpl>::ReferenceMapTag ReferenceMapTag;
 
-      typedef _Value Value;
+      typedef V Value;
       typedef Arc Key;
       typedef typename MapTraits<MapImpl>::ConstReturnValue ConstReturnValue;
@@ -2080,15 +2070,16 @@
       typedef typename MapTraits<MapImpl>::ReturnValue Reference;
 
-      ArcMapBase(const Adaptor& adaptor) :
+      ArcMapBase(const UndirectorBase<DGR>& adaptor) :
         _forward(*adaptor._digraph), _backward(*adaptor._digraph) {}
 
-      ArcMapBase(const Adaptor& adaptor, const Value& v)
-        : _forward(*adaptor._digraph, v), _backward(*adaptor._digraph, v) {}
-
-      void set(const Arc& a, const Value& v) {
+      ArcMapBase(const UndirectorBase<DGR>& adaptor, const V& value)
+        : _forward(*adaptor._digraph, value), 
+          _backward(*adaptor._digraph, value) {}
+
+      void set(const Arc& a, const V& value) {
         if (direction(a)) {
-          _forward.set(a, v);
+          _forward.set(a, value);
         } else {
-          _backward.set(a, v);
+          _backward.set(a, value);
         }
       }
@@ -2118,15 +2109,15 @@
   public:
 
-    template <typename _Value>
-    class NodeMap : public Digraph::template NodeMap<_Value> {
+    template <typename V>
+    class NodeMap : public DGR::template NodeMap<V> {
     public:
 
-      typedef _Value Value;
-      typedef typename Digraph::template NodeMap<Value> Parent;
-
-      explicit NodeMap(const Adaptor& adaptor)
+      typedef V Value;
+      typedef typename DGR::template NodeMap<Value> Parent;
+
+      explicit NodeMap(const UndirectorBase<DGR>& adaptor)
         : Parent(*adaptor._digraph) {}
 
-      NodeMap(const Adaptor& adaptor, const _Value& value)
+      NodeMap(const UndirectorBase<DGR>& adaptor, const V& value)
         : Parent(*adaptor._digraph, value) { }
 
@@ -2144,16 +2135,16 @@
     };
 
-    template <typename _Value>
+    template <typename V>
     class ArcMap
-      : public SubMapExtender<Adaptor, ArcMapBase<_Value> >
+      : public SubMapExtender<UndirectorBase<DGR>, ArcMapBase<V> >
     {
     public:
-      typedef _Value Value;
-      typedef SubMapExtender<Adaptor, ArcMapBase<Value> > Parent;
-
-      explicit ArcMap(const Adaptor& adaptor)
+      typedef V Value;
+      typedef SubMapExtender<Adaptor, ArcMapBase<V> > Parent;
+
+      explicit ArcMap(const UndirectorBase<DGR>& adaptor)
         : Parent(adaptor) {}
 
-      ArcMap(const Adaptor& adaptor, const Value& value)
+      ArcMap(const UndirectorBase<DGR>& adaptor, const V& value)
         : Parent(adaptor, value) {}
 
@@ -2170,15 +2161,15 @@
     };
 
-    template <typename _Value>
-    class EdgeMap : public Digraph::template ArcMap<_Value> {
+    template <typename V>
+    class EdgeMap : public Digraph::template ArcMap<V> {
     public:
 
-      typedef _Value Value;
-      typedef typename Digraph::template ArcMap<Value> Parent;
-
-      explicit EdgeMap(const Adaptor& adaptor)
+      typedef V Value;
+      typedef typename Digraph::template ArcMap<V> Parent;
+
+      explicit EdgeMap(const UndirectorBase<DGR>& adaptor)
         : Parent(*adaptor._digraph) {}
 
-      EdgeMap(const Adaptor& adaptor, const Value& value)
+      EdgeMap(const UndirectorBase<DGR>& adaptor, const V& value)
         : Parent(*adaptor._digraph, value) {}
 
@@ -2196,8 +2187,8 @@
     };
 
-    typedef typename ItemSetTraits<Digraph, Node>::ItemNotifier NodeNotifier;
+    typedef typename ItemSetTraits<DGR, Node>::ItemNotifier NodeNotifier;
     NodeNotifier& notifier(Node) const { return _digraph->notifier(Node()); }
 
-    typedef typename ItemSetTraits<Digraph, Edge>::ItemNotifier EdgeNotifier;
+    typedef typename ItemSetTraits<DGR, Edge>::ItemNotifier EdgeNotifier;
     EdgeNotifier& notifier(Edge) const { return _digraph->notifier(Edge()); }
 
@@ -2206,7 +2197,7 @@
     UndirectorBase() : _digraph(0) {}
 
-    Digraph* _digraph;
-
-    void setDigraph(Digraph& digraph) {
+    DGR* _digraph;
+
+    void initialize(DGR& digraph) {
       _digraph = &digraph;
     }
@@ -2227,5 +2218,5 @@
   /// parameter is set to be \c const.
   ///
-  /// \tparam GR The type of the adapted digraph.
+  /// \tparam DGR The type of the adapted digraph.
   /// It must conform to the \ref concepts::Digraph "Digraph" concept.
   /// It can also be specified to be \c const.
@@ -2237,15 +2228,15 @@
   /// (Thus the \c Arc type of the adaptor is convertible to the \c Arc type
   /// of the adapted digraph.)
-  template<typename GR>
+  template<typename DGR>
 #ifdef DOXYGEN
   class Undirector {
 #else
   class Undirector :
-    public GraphAdaptorExtender<UndirectorBase<GR> > {
+    public GraphAdaptorExtender<UndirectorBase<DGR> > {
 #endif
   public:
     /// The type of the adapted digraph.
-    typedef GR Digraph;
-    typedef GraphAdaptorExtender<UndirectorBase<GR> > Parent;
+    typedef DGR Digraph;
+    typedef GraphAdaptorExtender<UndirectorBase<DGR> > Parent;
   protected:
     Undirector() { }
@@ -2255,6 +2246,6 @@
     ///
     /// Creates an undirected graph from the given digraph.
-    Undirector(Digraph& digraph) {
-      setDigraph(digraph);
+    Undirector(DGR& digraph) {
+      initialize(digraph);
     }
 
@@ -2356,19 +2347,19 @@
   /// \ingroup graph_adaptors
   /// \relates Undirector
-  template<typename GR>
-  Undirector<const GR> undirector(const GR& digraph) {
-    return Undirector<const GR>(digraph);
+  template<typename DGR>
+  Undirector<const DGR> undirector(const DGR& digraph) {
+    return Undirector<const DGR>(digraph);
   }
 
 
-  template <typename _Graph, typename _DirectionMap>
+  template <typename GR, typename DM>
   class OrienterBase {
   public:
 
-    typedef _Graph Graph;
-    typedef _DirectionMap DirectionMap;
-
-    typedef typename Graph::Node Node;
-    typedef typename Graph::Edge Arc;
+    typedef GR Graph;
+    typedef DM DirectionMap;
+
+    typedef typename GR::Node Node;
+    typedef typename GR::Edge Arc;
 
     void reverseArc(const Arc& arc) {
@@ -2449,20 +2440,20 @@
     int maxArcId() const { return _graph->maxEdgeId(); }
 
-    typedef typename ItemSetTraits<Graph, Node>::ItemNotifier NodeNotifier;
+    typedef typename ItemSetTraits<GR, Node>::ItemNotifier NodeNotifier;
     NodeNotifier& notifier(Node) const { return _graph->notifier(Node()); }
 
-    typedef typename ItemSetTraits<Graph, Arc>::ItemNotifier ArcNotifier;
+    typedef typename ItemSetTraits<GR, Arc>::ItemNotifier ArcNotifier;
     ArcNotifier& notifier(Arc) const { return _graph->notifier(Arc()); }
 
-    template <typename _Value>
-    class NodeMap : public _Graph::template NodeMap<_Value> {
+    template <typename V>
+    class NodeMap : public GR::template NodeMap<V> {
     public:
 
-      typedef typename _Graph::template NodeMap<_Value> Parent;
-
-      explicit NodeMap(const OrienterBase& adapter)
+      typedef typename GR::template NodeMap<V> Parent;
+
+      explicit NodeMap(const OrienterBase<GR, DM>& adapter)
         : Parent(*adapter._graph) {}
 
-      NodeMap(const OrienterBase& adapter, const _Value& value)
+      NodeMap(const OrienterBase<GR, DM>& adapter, const V& value)
         : Parent(*adapter._graph, value) {}
 
@@ -2480,14 +2471,14 @@
     };
 
-    template <typename _Value>
-    class ArcMap : public _Graph::template EdgeMap<_Value> {
+    template <typename V>
+    class ArcMap : public GR::template EdgeMap<V> {
     public:
 
-      typedef typename Graph::template EdgeMap<_Value> Parent;
-
-      explicit ArcMap(const OrienterBase& adapter)
+      typedef typename Graph::template EdgeMap<V> Parent;
+
+      explicit ArcMap(const OrienterBase<GR, DM>& adapter)
         : Parent(*adapter._graph) { }
 
-      ArcMap(const OrienterBase& adapter, const _Value& value)
+      ArcMap(const OrienterBase<GR, DM>& adapter, const V& value)
         : Parent(*adapter._graph, value) { }
 
@@ -2508,12 +2499,9 @@
   protected:
     Graph* _graph;
-    DirectionMap* _direction;
-
-    void setDirectionMap(DirectionMap& direction) {
+    DM* _direction;
+
+    void initialize(GR& graph, DM& direction) {
+      _graph = &graph;
       _direction = &direction;
-    }
-
-    void setGraph(Graph& graph) {
-      _graph = &graph;
     }
 
@@ -2573,7 +2561,6 @@
     ///
     /// Constructor of the adaptor.
-    Orienter(Graph& graph, DirectionMap& direction) {
-      setGraph(graph);
-      setDirectionMap(direction);
+    Orienter(GR& graph, DM& direction) {
+      Parent::initialize(graph, direction);
     }
 
